{Object_Title_and_Purpose}


CON
        max_pos = 1023
        min_pos = 0
        max_id = 254
        min_id = 0
        

VAR
  long  rx485         'pin numbers
  long  dir485
  long  tx485
  long  Dyna_baud
  byte  ptbuff[20]
   
OBJ
  X : "jm_hd485"
  
pub start(_rx485, _tx485, _dir485, _Dyna_baud)
  'start jm_hd485 to run serial port
  '_tx485 = transmit pin on prop
  '_rx485 = recieve pin on prop
  '_dir485 = direction pin on prop
  '
  tx485 := _tx485
  rx485 := _rx485
  dir485 := _dir485
  Dyna_baud := _Dyna_baud
  X.start(rx485, tx485, dir485, -1, Dyna_baud)
  dira[dir485] := 1             'set direction pin to an output
                                'default pin state puts buffer chip in input mode
  

pub move_rx24f(idm, pos) | temp, idx
{{ just the barest bones code to move a RX-24F servo
  result is the status code in the ACK packet
  }}
  'bounds check inputs
  pos := min_pos #> pos <# max_pos                      'bounds check position
  idm := min_id #> idm <# max_id        'bounds check servo ID

  'assemble a packet to write to the "goal position" register
  ptbuff[0] := $FF
  ptbuff[1] := $FF              'start of packet flag
  ptbuff[2] := IDm               'actuator ID
  ptbuff[3] := 5                'length, bytes between ID and checksum
  ptbuff[4] := $03              'instruction (write data)
  ptbuff[5] := $1e              'address of goal position
  ptbuff[6] := pos & $FF              'low byte
  ptbuff[7] := pos >> 8              'high byte
  temp := 0
  repeat idx from 2 to 7
    temp += ptbuff[idx]  
  ptbuff[8] := !(temp)          'check sum

  'transmit the packet
  repeat idx from 0 to 8        'transmit packet
    x.tx(ptbuff[idx])
  X.tx_flush
  X.rx_flush                     'clean out any junk bytes

  'listen for an ACK packet
  repeat idx from 0 to 5       
    temp := x.rx_time(1)         'the RX-24F responds well before 1 [mS]
    if not(temp + 1)
      quit
    else
      ptbuff[idx] := temp

  'extract the status byte        
  result := ptbuff[4]